# If not provided by a system installed macro, define
%{!?__python2: %global __python2 /usr/bin/python2}

%if %{_vendor} == "debbuild"
%global pyinstflags --no-compile -O0
%global pytargetflags --install-layout=deb
%else
%global pyinstflags -O1
%global pytargetflags %{nil}
%endif

%{!?py2_build: %global py2_build CFLAGS="%{optflags}" %{__python2} setup.py build}
%{!?py2_install: %global py2_install %{__python2} setup.py install %{?pyinstflags} --skip-build --root %{buildroot} %{?pytargetflags}}

%if %{undefined python2_sitelib}
%global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")
%endif

%if 0%{?fedora} >= 28 || 0%{?rhel} >= 8 || 0%{?suse_version} >= 1330
%global python2_pkgversion 2
%else
%global python2_pkgversion %{nil}
%endif

# On Fedora 25+, enable the python distdeps generator for requires
# See https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_Packages
%if 0%{?fedora} >= 25
%global __python_requires %{_rpmconfigdir}/pythondistdeps.py --requires
%endif


# User "--with devmode" on rpmbuild/debbuild to enable devmode
# like so: "debbuild -bb --with devmode vmscripts.spec"
%bcond_with devmode


Name:           obsctl
Version:        0.3.9
Release:        1%{?dist}
Summary:        Unified high level interface for common actions with the Open Build Service
URL:            https://gitlab.datto.net/DevOps/obsctl
%if ! %{with devmode}
Source0:        %{name}-%{version}.tar.gz
%else
Source0:        %{name}.tar.gz
%endif
%if %{_vendor} == "debbuild" || %{_vendor} == "suse"
License:        GPL-2.0+
%else
License:        GPLv2+
%endif

%if %{_vendor} == "debbuild"
Packager:       Neal Gompa <ngompa@datto.com>
Group:          devel
%else
Group:          Development/Tools%{?suse_version:/Other}
%endif

BuildArch: noarch

%if %{_vendor} == "debbuild"
BuildRequires:  python%{python2_pkgversion}-dev
BuildRequires:  python%{python2_pkgversion}-wheel
%else
BuildRequires:  python%{python2_pkgversion}-devel
%endif

BuildRequires:  python%{python2_pkgversion}-setuptools
BuildRequires:  python%{python2_pkgversion}-click
BuildRequires:  python%{python2_pkgversion}-pathlib
BuildRequires:  python%{python2_pkgversion}-lxml
BuildRequires:  osc

Requires:       python%{python2_pkgversion}-setuptools
Requires:       python%{python2_pkgversion}-click
Requires:       python%{python2_pkgversion}-pathlib
Requires:       python%{python2_pkgversion}-lxml
Requires:       osc

# For the source services obsctl uses
# For specimport, tarimport, and scratchbuild
Requires:       obs-service-download_files
# For tarimport and scratchbuild
Requires:       obs-service-extract_file
# For scratchbuild
Requires:       obs-service-set_version

%description
This is a command line interface to simplify the packaging and deploy process
for packages built in the openSUSE Open Build Service. This utility functions
in a non-interactive manner allowing it to be utilized in continuous integration
and continuous deployment infrastructure.

%prep
%if ! %{with devmode}
%autosetup -n %{name}-%{version}
%else
%autosetup -n %{name}
%endif

%build
%py2_build


%install
%py2_install


mkdir -p %{buildroot}%{_sysconfdir}/obsctl
%if %{_vendor} != "debbuild"
touch %{buildroot}%{_sysconfdir}/obsctl/obsauth.json
%endif

%if %{_vendor} == "debbuild"
touch %{buildroot}%{_sysconfdir}/obsctl/.keep
%endif

%files
%license COPYING
%dir %{_sysconfdir}/obsctl
%if %{_vendor} == "debbuild"
%{_sysconfdir}/obsctl/.keep
%else
%ghost %{_sysconfdir}/obsctl/obsauth.json
%endif
%{_bindir}/obsctl
%{python2_sitelib}/obsctl-*.egg-info
%{python2_sitelib}/obsctl


%changelog
* Thu Dec 14 2017 Neal Gompa <ngompa@datto.com> - 0.3.9
- Fix prerel spec version generation

* Tue Dec 12 2017 Neal Gompa <ngompa@datto.com> - 0.3.8
- Fix pattern match for generated _service in tarimport

* Tue Dec 12 2017 Neal Gompa <ngompa@datto.com> - 0.3.7
- Fill in the setuptools metadata
- scratchbuild, tarimport: Add option to set non-default path to extract spec file

* Fri Dec 08 2017 Neal Gompa <ngompa@datto.com> - 0.3.6
- Revert scratchbuild changes in 0.3.4 and 0.3.5

* Fri Dec 08 2017 Neal Gompa <ngompa@datto.com> - 0.3.5
- scratchbuild: Use restricted matching for generated directory

* Fri Dec 08 2017 Neal Gompa <ngompa@datto.com> - 0.3.4
- Print out where people can see the OBS build for obsimport commands
- scratchbuild: Use exact name of the generated directory for spec extraction

* Thu Nov 30 2017 Neal Gompa <ngompa@datto.com> - 0.3.3
- Add download_files service support to scratchbuild

* Thu Nov 30 2017 Neal Gompa <ngompa@datto.com> - 0.3.2
- Add download_files service support to tarimport

* Wed Nov 29 2017 Neal Gompa <ngompa@datto.com> - 0.3.1
- Fix _service file existence check in dscimport

* Wed Nov 29 2017 Neal Gompa <ngompa@datto.com> - 0.3.0
- Implement dscimport for dsc packaging repos

* Tue Nov 28 2017 Neal Gompa <ngompa@datto.com> - 0.2.10
- Add explicit dependencies for required OBS source services
- Ensure scratchbuild ignores hidden files (dotfiles)

* Wed Nov 22 2017 Neal Gompa <ngompa@datto.com> - 0.2.9
- Refactor scratchbuild to not require checkout of OBS package

* Wed Nov 22 2017 Neal Gompa <ngompa@datto.com> - 0.2.8
- Add missing import for os to tarimport

* Wed Nov 22 2017 Neal Gompa <ngompa@datto.com> - 0.2.7
- Remove accidental superfluous delete command

* Wed Nov 22 2017 Neal Gompa <ngompa@datto.com> - 0.2.6
- Fix tarimport and tarball creation logic

* Wed Nov 22 2017 Neal Gompa <ngompa@datto.com> - 0.2.5
- Mark '--source-file' as a required arg for scratchbuild and tarimport

* Wed Nov 22 2017 Neal Gompa <ngompa@datto.com> - 0.2.4
- The scratchbuild command now requires a path to an existing tarball
- Librarized the tarball regeneration logic into new internal tar lib
- Fix osc config generation to keep tempfile for the whole run

* Tue Nov 21 2017 Neal Gompa <ngompa@datto.com> - 0.2.3
- Bump version

* Tue Nov 21 2017 Neal Gompa <ngompa@datto.com> - 0.2.2
- Add missing runtime dependency on setuptools for obsctl executable

* Tue Nov 21 2017 Neal Gompa <ngompa@datto.com> - 0.2.1
- Add initial spec internal library module
- Unify logic in scratchbuild and {tar,spec}import commands
- Make the CLI arguments consistent across commands

* Thu Nov 16 2017 Neal Gompa <ngompa@datto.com> - 0.2.0
- Rename tarsrc-obsimport to tarimport
- Implement specimport for spec+patches repos
- Make tarimport and specimport use the same releasing code in obsc library
- Fix python2_pkgversion conditional in spec for Fedora 27

* Wed Nov 15 2017 Mark Bluemer <mbluemer@datto.com> - 0.1.9
- Bump version

* Wed Nov 15 2017 Mark Bluemer <mbluemer@datto.com> - 0.1.8
- Bump version

* Wed Nov 15 2017 Mark Bluemer <mbluemer@datto.com> - 0.1.7
- Fix tarsrc_obsimport script

* Tue Nov 14 2017 Neal Gompa <ngompa@datto.com> - 0.1.6
- Reword one of the options to match the original script

* Tue Nov 14 2017 Mark Bluemer <mbluemer@datto.com> - 0.1.5
- bump version with addition of CI

* Mon Nov 13 2017 Neal Gompa <ngompa@datto.com> - 0.1.4
- Fix local definition of python2_sitelib

* Mon Nov 13 2017 Neal Gompa <ngompa@datto.com> - 0.1.3
- Consistently use python2_pkgversion macro in spec
- Fix ghost file entry typo
- Add bobs and bits to make openSUSE builds happy

* Mon Nov 13 2017 Neal Gompa <ngompa@datto.com> - 0.1.2
- Revise build-time dependencies to be cross-distribution
- Add missing runtime dependencies
- Wrap the description correctly

* Mon Nov 13 2017 Mark Bluemer <mbluemer@datto.com> - 0.1.1
- Add ghost configuration file for auth information

* Fri Nov 10 2017 Mark Bluemer <mbluemer@datto.com> - 0.1.0
- Inital Packaging

